## Service-side media streaming helper interfaces

Service-side media streaming helper interfaces — media session and media stream

## Functions

void | (*tp_svc_media_session_handler_error_impl) ()
void | tp_svc_media_session_handler_implement_error ()
void | tp_svc_media_session_handler_return_from_error ()
void | (*tp_svc_media_session_handler_ready_impl) ()
void | tp_svc_media_session_handler_implement_ready ()
void | tp_svc_media_session_handler_return_from_ready ()
void | tp_svc_media_session_handler_emit_new_stream_handler ()
void | (*tp_svc_media_stream_handler_codec_choice_impl) ()
void | tp_svc_media_stream_handler_implement_codec_choice ()
void | tp_svc_media_stream_handler_return_from_codec_choice ()
void | (*tp_svc_media_stream_handler_error_impl) ()
void | tp_svc_media_stream_handler_implement_error ()
void | tp_svc_media_stream_handler_return_from_error ()
void | (*tp_svc_media_stream_handler_native_candidates_prepared_impl) ()
void | tp_svc_media_stream_handler_implement_native_candidates_prepared ()
void | tp_svc_media_stream_handler_return_from_native_candidates_prepared ()
void | (*tp_svc_media_stream_handler_new_active_candidate_pair_impl) ()
void | tp_svc_media_stream_handler_implement_new_active_candidate_pair ()
void | tp_svc_media_stream_handler_return_from_new_active_candidate_pair ()
void | (*tp_svc_media_stream_handler_new_native_candidate_impl) ()
void | tp_svc_media_stream_handler_implement_new_native_candidate ()
void | tp_svc_media_stream_handler_return_from_new_native_candidate ()
void | (*tp_svc_media_stream_handler_ready_impl) ()
void | tp_svc_media_stream_handler_implement_ready ()
void | tp_svc_media_stream_handler_return_from_ready ()
void | (*tp_svc_media_stream_handler_set_local_codecs_impl) ()
void | tp_svc_media_stream_handler_implement_set_local_codecs ()
void | tp_svc_media_stream_handler_return_from_set_local_codecs ()
void | (*tp_svc_media_stream_handler_stream_state_impl) ()
void | tp_svc_media_stream_handler_implement_stream_state ()
void | tp_svc_media_stream_handler_return_from_stream_state ()
void | (*tp_svc_media_stream_handler_supported_codecs_impl) ()
void | tp_svc_media_stream_handler_implement_supported_codecs ()
void | tp_svc_media_stream_handler_return_from_supported_codecs ()
void | tp_svc_media_stream_handler_emit_add_remote_candidate ()
void | tp_svc_media_stream_handler_emit_close ()
void | tp_svc_media_stream_handler_emit_remove_remote_candidate ()
void | tp_svc_media_stream_handler_emit_set_active_candidate_pair ()
void | tp_svc_media_stream_handler_emit_set_remote_candidate_list ()
void | tp_svc_media_stream_handler_emit_set_remote_codecs ()
void | tp_svc_media_stream_handler_emit_set_stream_playing ()
void | tp_svc_media_stream_handler_emit_set_stream_sending ()
void | tp_svc_media_stream_handler_emit_start_telephony_event ()
void | tp_svc_media_stream_handler_emit_stop_telephony_event ()
void | tp_svc_media_stream_handler_emit_set_stream_held ()
void | (*tp_svc_media_stream_handler_hold_state_impl) ()
void | tp_svc_media_stream_handler_implement_hold_state ()
void | tp_svc_media_stream_handler_implement_unhold_failure ()
void | tp_svc_media_stream_handler_return_from_hold_state ()
void | tp_svc_media_stream_handler_return_from_unhold_failure ()
void | (*tp_svc_media_stream_handler_unhold_failure_impl) ()
void | (*tp_svc_media_stream_handler_codecs_updated_impl) ()
void | tp_svc_media_stream_handler_implement_codecs_updated ()
void | tp_svc_media_stream_handler_return_from_codecs_updated ()
void | tp_svc_media_stream_handler_emit_start_named_telephony_event ()
void | tp_svc_media_stream_handler_emit_start_sound_telephony_event ()
void | tp_svc_media_stream_handler_implement_new_active_transport_pair ()
void | (*tp_svc_media_stream_handler_new_active_transport_pair_impl) ()
void | tp_svc_media_stream_handler_return_from_new_active_transport_pair ()
void | tp_svc_media_stream_handler_emit_set_remote_feedback_messages ()
void | tp_svc_media_stream_handler_emit_set_remote_header_extensions ()
void | tp_svc_media_stream_handler_implement_supported_feedback_messages ()
void | tp_svc_media_stream_handler_implement_supported_header_extensions ()
void | tp_svc_media_stream_handler_return_from_supported_feedback_messages ()
void | tp_svc_media_stream_handler_return_from_supported_header_extensions ()
void | (*tp_svc_media_stream_handler_supported_feedback_messages_impl) ()
void | (*tp_svc_media_stream_handler_supported_header_extensions_impl) ()

## Signals

void | new-stream-handler | Has Details
void | add-remote-candidate | Has Details
void | close | Has Details
void | remove-remote-candidate | Has Details
void | set-active-candidate-pair | Has Details
void | set-remote-candidate-list | Has Details
void | set-remote-codecs | Has Details
void | set-remote-feedback-messages | Has Details
void | set-remote-header-extensions | Has Details
void | set-stream-held | Has Details
void | set-stream-playing | Has Details
void | set-stream-sending | Has Details
void | start-named-telephony-event | Has Details
void | start-sound-telephony-event | Has Details
void | start-telephony-event | Has Details
void | stop-telephony-event | Has Details

## Types and Values

| TpSvcMediaSessionHandler
| TpSvcMediaSessionHandlerClass
| TpSvcMediaStreamHandler
| TpSvcMediaStreamHandlerClass

## Object Hierarchy

        GInterface
        ├── TpSvcMediaSessionHandler
        ╰── TpSvcMediaStreamHandler

## Includes

    #include <telepathy-glib/telepathy-glib-dbus.h>

## Description

These interfaces (auto-generated from the telepathy spec) make it easier to export the objects used to implement TpSvcChannelTypeStreamedMedia, with the correct method and signal signatures, and emit signals from those objects.

## Functions

### tp_svc_media_session_handler_error_impl ()

    void
    (*tp_svc_media_session_handler_error_impl)
                                   (TpSvcMediaSessionHandler *self,
                                    guint in_Error_Code,
                                    const gchar *in_Message,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method Error on interface org.freedesktop.Telepathy.Media.SessionHandler.

#### Parameters

self | The object implementing this interface |
in_Error_Code | guint (FIXME, generate documentation) |
in_Message | const gchar * (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_session_handler_implement_error ()

    void
    tp_svc_media_session_handler_implement_error
                                   (TpSvcMediaSessionHandlerClass *klass,
                                    tp_svc_media_session_handler_error_impl impl);

Register an implementation for the Error method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the Error D-Bus method |

### tp_svc_media_session_handler_return_from_error ()

    void
    tp_svc_media_session_handler_return_from_error
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_session_handler_ready_impl ()

    void
    (*tp_svc_media_session_handler_ready_impl)
                                   (TpSvcMediaSessionHandler *self,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method Ready on interface org.freedesktop.Telepathy.Media.SessionHandler.

#### Parameters

self | The object implementing this interface |
context | Used to return values or throw an error |

### tp_svc_media_session_handler_implement_ready ()

    void
    tp_svc_media_session_handler_implement_ready
                                   (TpSvcMediaSessionHandlerClass *klass,
                                    tp_svc_media_session_handler_ready_impl impl);

Register an implementation for the Ready method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the Ready D-Bus method |

### tp_svc_media_session_handler_return_from_ready ()

    void
    tp_svc_media_session_handler_return_from_ready
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_session_handler_emit_new_stream_handler ()

    void
    tp_svc_media_session_handler_emit_new_stream_handler
                                   (gpointer instance,
                                    const gchar *arg_Stream_Handler,
                                    guint arg_ID,
                                    guint arg_Media_Type,
                                    guint arg_Direction);

Type-safe wrapper around g_signal_emit to emit the NewStreamHandler signal on interface org.freedesktop.Telepathy.Media.SessionHandler.

#### Parameters

instance | The object implementing this interface |
arg_Stream_Handler | const gchar * (FIXME, generate documentation) |
arg_ID | guint (FIXME, generate documentation) |
arg_Media_Type | guint (FIXME, generate documentation) |
arg_Direction | guint (FIXME, generate documentation) |

### tp_svc_media_stream_handler_codec_choice_impl ()

    void
    (*tp_svc_media_stream_handler_codec_choice_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    guint in_Codec_ID,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method CodecChoice on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_Codec_ID | guint (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_implement_codec_choice ()

    void
    tp_svc_media_stream_handler_implement_codec_choice
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_codec_choice_impl impl);

Register an implementation for the CodecChoice method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the CodecChoice D-Bus method |

### tp_svc_media_stream_handler_return_from_codec_choice ()

    void
    tp_svc_media_stream_handler_return_from_codec_choice
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_error_impl ()

    void
    (*tp_svc_media_stream_handler_error_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    guint in_Error_Code,
                                    const gchar *in_Message,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method Error on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_Error_Code | guint (FIXME, generate documentation) |
in_Message | const gchar * (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_implement_error ()

    void
    tp_svc_media_stream_handler_implement_error
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_error_impl impl);

Register an implementation for the Error method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the Error D-Bus method |

### tp_svc_media_stream_handler_return_from_error ()

    void
    tp_svc_media_stream_handler_return_from_error
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_native_candidates_prepared_impl ()

    void
    (*tp_svc_media_stream_handler_native_candidates_prepared_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method NativeCandidatesPrepared on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_implement_native_candidates_prepared ()

    void
    tp_svc_media_stream_handler_implement_native_candidates_prepared
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_native_candidates_prepared_impl impl);

Register an implementation for the NativeCandidatesPrepared method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the NativeCandidatesPrepared D-Bus method |

### tp_svc_media_stream_handler_return_from_native_candidates_prepared ()

    void
    tp_svc_media_stream_handler_return_from_native_candidates_prepared
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_new_active_candidate_pair_impl ()

    void
    (*tp_svc_media_stream_handler_new_active_candidate_pair_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    const gchar *in_Native_Candidate_ID,
                                    const gchar *in_Remote_Candidate_ID,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method NewActiveCandidatePair on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_Native_Candidate_ID | const gchar * (FIXME, generate documentation) |
in_Remote_Candidate_ID | const gchar * (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_implement_new_active_candidate_pair ()

    void
    tp_svc_media_stream_handler_implement_new_active_candidate_pair
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_new_active_candidate_pair_impl impl);

Register an implementation for the NewActiveCandidatePair method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the NewActiveCandidatePair D-Bus method |

### tp_svc_media_stream_handler_return_from_new_active_candidate_pair ()

    void
    tp_svc_media_stream_handler_return_from_new_active_candidate_pair
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_new_native_candidate_impl ()

    void
    (*tp_svc_media_stream_handler_new_native_candidate_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    const gchar *in_Candidate_ID,
                                    const GPtrArray *in_Transports,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method NewNativeCandidate on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_Candidate_ID | const gchar * (FIXME, generate documentation) |
in_Transports | const GPtrArray * (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_implement_new_native_candidate ()

    void
    tp_svc_media_stream_handler_implement_new_native_candidate
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_new_native_candidate_impl impl);

Register an implementation for the NewNativeCandidate method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the NewNativeCandidate D-Bus method |

### tp_svc_media_stream_handler_return_from_new_native_candidate ()

    void
    tp_svc_media_stream_handler_return_from_new_native_candidate
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_ready_impl ()

    void
    (*tp_svc_media_stream_handler_ready_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    const GPtrArray *in_Codecs,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method Ready on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_Codecs | const GPtrArray * (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_implement_ready ()

    void
    tp_svc_media_stream_handler_implement_ready
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_ready_impl impl);

Register an implementation for the Ready method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the Ready D-Bus method |

### tp_svc_media_stream_handler_return_from_ready ()

    void
    tp_svc_media_stream_handler_return_from_ready
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_set_local_codecs_impl ()

    void
    (*tp_svc_media_stream_handler_set_local_codecs_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    const GPtrArray *in_Codecs,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method SetLocalCodecs on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_Codecs | const GPtrArray * (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_implement_set_local_codecs ()

    void
    tp_svc_media_stream_handler_implement_set_local_codecs
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_set_local_codecs_impl impl);

Register an implementation for the SetLocalCodecs method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the SetLocalCodecs D-Bus method |

### tp_svc_media_stream_handler_return_from_set_local_codecs ()

    void
    tp_svc_media_stream_handler_return_from_set_local_codecs
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_stream_state_impl ()

    void
    (*tp_svc_media_stream_handler_stream_state_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    guint in_State,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method StreamState on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_State | guint (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_implement_stream_state ()

    void
    tp_svc_media_stream_handler_implement_stream_state
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_stream_state_impl impl);

Register an implementation for the StreamState method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the StreamState D-Bus method |

### tp_svc_media_stream_handler_return_from_stream_state ()

    void
    tp_svc_media_stream_handler_return_from_stream_state
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_supported_codecs_impl ()

    void
    (*tp_svc_media_stream_handler_supported_codecs_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    const GPtrArray *in_Codecs,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method SupportedCodecs on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_Codecs | const GPtrArray * (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_implement_supported_codecs ()

    void
    tp_svc_media_stream_handler_implement_supported_codecs
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_supported_codecs_impl impl);

Register an implementation for the SupportedCodecs method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the SupportedCodecs D-Bus method |

### tp_svc_media_stream_handler_return_from_supported_codecs ()

    void
    tp_svc_media_stream_handler_return_from_supported_codecs
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_emit_add_remote_candidate ()

    void
    tp_svc_media_stream_handler_emit_add_remote_candidate
                                   (gpointer instance,
                                    const gchar *arg_Candidate_ID,
                                    const GPtrArray *arg_Transports);

Type-safe wrapper around g_signal_emit to emit the AddRemoteCandidate signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Candidate_ID | const gchar * (FIXME, generate documentation) |
arg_Transports | const GPtrArray * (FIXME, generate documentation) |

### tp_svc_media_stream_handler_emit_close ()

    void
    tp_svc_media_stream_handler_emit_close
                                   (gpointer instance);

Type-safe wrapper around g_signal_emit to emit the Close signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |

### tp_svc_media_stream_handler_emit_remove_remote_candidate ()

    void
    tp_svc_media_stream_handler_emit_remove_remote_candidate
                                   (gpointer instance,
                                    const gchar *arg_Candidate_ID);

Type-safe wrapper around g_signal_emit to emit the RemoveRemoteCandidate signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Candidate_ID | const gchar * (FIXME, generate documentation) |

### tp_svc_media_stream_handler_emit_set_active_candidate_pair ()

    void
    tp_svc_media_stream_handler_emit_set_active_candidate_pair
                                   (gpointer instance,
                                    const gchar *arg_Native_Candidate_ID,
                                    const gchar *arg_Remote_Candidate_ID);

Type-safe wrapper around g_signal_emit to emit the SetActiveCandidatePair signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Native_Candidate_ID | const gchar * (FIXME, generate documentation) |
arg_Remote_Candidate_ID | const gchar * (FIXME, generate documentation) |

### tp_svc_media_stream_handler_emit_set_remote_candidate_list ()

    void
    tp_svc_media_stream_handler_emit_set_remote_candidate_list
                                   (gpointer instance,
                                    const GPtrArray *arg_Remote_Candidates);

Type-safe wrapper around g_signal_emit to emit the SetRemoteCandidateList signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Remote_Candidates | const GPtrArray * (FIXME, generate documentation) |

### tp_svc_media_stream_handler_emit_set_remote_codecs ()

    void
    tp_svc_media_stream_handler_emit_set_remote_codecs
                                   (gpointer instance,
                                    const GPtrArray *arg_Codecs);

Type-safe wrapper around g_signal_emit to emit the SetRemoteCodecs signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Codecs | const GPtrArray * (FIXME, generate documentation) |

### tp_svc_media_stream_handler_emit_set_stream_playing ()

    void
    tp_svc_media_stream_handler_emit_set_stream_playing
                                   (gpointer instance,
                                    gboolean arg_Playing);

Type-safe wrapper around g_signal_emit to emit the SetStreamPlaying signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Playing | gboolean (FIXME, generate documentation) |

### tp_svc_media_stream_handler_emit_set_stream_sending ()

    void
    tp_svc_media_stream_handler_emit_set_stream_sending
                                   (gpointer instance,
                                    gboolean arg_Sending);

Type-safe wrapper around g_signal_emit to emit the SetStreamSending signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Sending | gboolean (FIXME, generate documentation) |

### tp_svc_media_stream_handler_emit_start_telephony_event ()

    void
    tp_svc_media_stream_handler_emit_start_telephony_event
                                   (gpointer instance,
                                    guchar arg_Event);

Type-safe wrapper around g_signal_emit to emit the StartTelephonyEvent signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Event | guchar (FIXME, generate documentation) |

### tp_svc_media_stream_handler_emit_stop_telephony_event ()

    void
    tp_svc_media_stream_handler_emit_stop_telephony_event
                                   (gpointer instance);

Type-safe wrapper around g_signal_emit to emit the StopTelephonyEvent signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |

### tp_svc_media_stream_handler_emit_set_stream_held ()

    void
    tp_svc_media_stream_handler_emit_set_stream_held
                                   (gpointer instance,
                                    gboolean arg_Held);

Type-safe wrapper around g_signal_emit to emit the SetStreamHeld signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Held | gboolean (FIXME, generate documentation) |

### tp_svc_media_stream_handler_hold_state_impl ()

    void
    (*tp_svc_media_stream_handler_hold_state_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    gboolean in_Held,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method HoldState on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_Held | gboolean (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_implement_hold_state ()

    void
    tp_svc_media_stream_handler_implement_hold_state
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_hold_state_impl impl);

Register an implementation for the HoldState method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the HoldState D-Bus method |

### tp_svc_media_stream_handler_implement_unhold_failure ()

    void
    tp_svc_media_stream_handler_implement_unhold_failure
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_unhold_failure_impl impl);

Register an implementation for the UnholdFailure method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the UnholdFailure D-Bus method |

### tp_svc_media_stream_handler_return_from_hold_state ()

    void
    tp_svc_media_stream_handler_return_from_hold_state
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_return_from_unhold_failure ()

    void
    tp_svc_media_stream_handler_return_from_unhold_failure
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_unhold_failure_impl ()

    void
    (*tp_svc_media_stream_handler_unhold_failure_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method UnholdFailure on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_codecs_updated_impl ()

    void
    (*tp_svc_media_stream_handler_codecs_updated_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    const GPtrArray *in_Codecs,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method CodecsUpdated on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_Codecs | const GPtrArray * (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_implement_codecs_updated ()

    void
    tp_svc_media_stream_handler_implement_codecs_updated
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_codecs_updated_impl impl);

Register an implementation for the CodecsUpdated method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the CodecsUpdated D-Bus method |

### tp_svc_media_stream_handler_return_from_codecs_updated ()

    void
    tp_svc_media_stream_handler_return_from_codecs_updated
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_emit_start_named_telephony_event ()

    void
    tp_svc_media_stream_handler_emit_start_named_telephony_event
                                   (gpointer instance,
                                    guchar arg_Event,
                                    guint arg_Codec_ID);

Type-safe wrapper around g_signal_emit to emit the StartNamedTelephonyEvent signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Event | guchar (FIXME, generate documentation) |
arg_Codec_ID | guint (FIXME, generate documentation) |

### tp_svc_media_stream_handler_emit_start_sound_telephony_event ()

    void
    tp_svc_media_stream_handler_emit_start_sound_telephony_event
                                   (gpointer instance,
                                    guchar arg_Event);

Type-safe wrapper around g_signal_emit to emit the StartSoundTelephonyEvent signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Event | guchar (FIXME, generate documentation) |

### tp_svc_media_stream_handler_implement_new_active_transport_pair ()

    void
    tp_svc_media_stream_handler_implement_new_active_transport_pair
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_new_active_transport_pair_impl impl);

Register an implementation for the NewActiveTransportPair method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the NewActiveTransportPair D-Bus method |

### tp_svc_media_stream_handler_new_active_transport_pair_impl ()

    void
    (*tp_svc_media_stream_handler_new_active_transport_pair_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    const gchar *in_Native_Candidate_ID,
                                    const GValueArray *in_Native_Transport,
                                    const gchar *in_Remote_Candidate_ID,
                                    const GValueArray *in_Remote_Transport,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method NewActiveTransportPair on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_Native_Candidate_ID | const gchar * (FIXME, generate documentation) |
in_Native_Transport | const GValueArray * (FIXME, generate documentation) |
in_Remote_Candidate_ID | const gchar * (FIXME, generate documentation) |
in_Remote_Transport | const GValueArray * (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_return_from_new_active_transport_pair ()

    void
    tp_svc_media_stream_handler_return_from_new_active_transport_pair
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_emit_set_remote_feedback_messages ()

    void
    tp_svc_media_stream_handler_emit_set_remote_feedback_messages
                                   (gpointer instance,
                                    GHashTable *arg_Messages);

Type-safe wrapper around g_signal_emit to emit the SetRemoteFeedbackMessages signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Messages | GHashTable * (FIXME, generate documentation) |

### tp_svc_media_stream_handler_emit_set_remote_header_extensions ()

    void
    tp_svc_media_stream_handler_emit_set_remote_header_extensions
                                   (gpointer instance,
                                    const GPtrArray *arg_Header_Extensions);

Type-safe wrapper around g_signal_emit to emit the SetRemoteHeaderExtensions signal on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

instance | The object implementing this interface |
arg_Header_Extensions | const GPtrArray * (FIXME, generate documentation) |

### tp_svc_media_stream_handler_implement_supported_feedback_messages ()

    void
    tp_svc_media_stream_handler_implement_supported_feedback_messages
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_supported_feedback_messages_impl impl);

Register an implementation for the SupportedFeedbackMessages method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the SupportedFeedbackMessages D-Bus method |

### tp_svc_media_stream_handler_implement_supported_header_extensions ()

    void
    tp_svc_media_stream_handler_implement_supported_header_extensions
                                   (TpSvcMediaStreamHandlerClass *klass,
                                    tp_svc_media_stream_handler_supported_header_extensions_impl impl);

Register an implementation for the SupportedHeaderExtensions method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the SupportedHeaderExtensions D-Bus method |

### tp_svc_media_stream_handler_return_from_supported_feedback_messages ()

    void
    tp_svc_media_stream_handler_return_from_supported_feedback_messages
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_return_from_supported_header_extensions ()

    void
    tp_svc_media_stream_handler_return_from_supported_header_extensions
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_media_stream_handler_supported_feedback_messages_impl ()

    void
    (*tp_svc_media_stream_handler_supported_feedback_messages_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    GHashTable *in_Messages,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method SupportedFeedbackMessages on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_Messages | GHashTable * (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_media_stream_handler_supported_header_extensions_impl ()

    void
    (*tp_svc_media_stream_handler_supported_header_extensions_impl)
                                   (TpSvcMediaStreamHandler *self,
                                    const GPtrArray *in_Header_Extensions,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method SupportedHeaderExtensions on interface org.freedesktop.Telepathy.Media.StreamHandler.

#### Parameters

self | The object implementing this interface |
in_Header_Extensions | const GPtrArray * (FIXME, generate documentation) |
context | Used to return values or throw an error |

## Types and Values

### TpSvcMediaSessionHandler

    typedef struct _TpSvcMediaSessionHandler TpSvcMediaSessionHandler;

Dummy typedef representing any implementation of this interface.

### TpSvcMediaSessionHandlerClass

    typedef struct _TpSvcMediaSessionHandlerClass TpSvcMediaSessionHandlerClass;

The class of TpSvcMediaSessionHandler.

In a full implementation of this interface (i.e. all methods implemented), the interface initialization function used in `G_IMPLEMENT_INTERFACE()` would typically look like this:

    static void
    implement_media_session_handler (gpointer klass,
        gpointer unused G_GNUC_UNUSED)
    {
    #define IMPLEMENT(x) tp_svc_media_session_handler_implement_##x (\
      klass, my_object_##x)
      IMPLEMENT (error);
      IMPLEMENT (ready);
    #undef IMPLEMENT
    }

### TpSvcMediaStreamHandler

    typedef struct _TpSvcMediaStreamHandler TpSvcMediaStreamHandler;

Dummy typedef representing any implementation of this interface.

### TpSvcMediaStreamHandlerClass

    typedef struct _TpSvcMediaStreamHandlerClass TpSvcMediaStreamHandlerClass;

The class of TpSvcMediaStreamHandler.

In a full implementation of this interface (i.e. all methods implemented), the interface initialization function used in `G_IMPLEMENT_INTERFACE()` would typically look like this:

    static void
    implement_media_stream_handler (gpointer klass,
        gpointer unused G_GNUC_UNUSED)
    {
    #define IMPLEMENT(x) tp_svc_media_stream_handler_implement_##x (\
      klass, my_object_##x)
      IMPLEMENT (codec_choice);
      IMPLEMENT (error);
      IMPLEMENT (native_candidates_prepared);
      IMPLEMENT (new_active_candidate_pair);
      IMPLEMENT (new_active_transport_pair);
      IMPLEMENT (new_native_candidate);
      IMPLEMENT (ready);
      IMPLEMENT (set_local_codecs);
      IMPLEMENT (stream_state);
      IMPLEMENT (supported_codecs);
      IMPLEMENT (codecs_updated);
      IMPLEMENT (hold_state);
      IMPLEMENT (unhold_failure);
      IMPLEMENT (supported_feedback_messages);
      IMPLEMENT (supported_header_extensions);
    #undef IMPLEMENT
    }

## Signal Details

### The `“new-stream-handler”` signal

    void
    user_function (TpSvcMediaSessionHandler *self,
                   DBusGObjectPath          *arg_Stream_Handler,
                   guint                     arg_ID,
                   guint                     arg_Media_Type,
                   guint                     arg_Direction,
                   gpointer                  user_data)

The NewStreamHandler D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Stream_Handler | const gchar * (FIXME, generate documentation) |
arg_ID | guint (FIXME, generate documentation) |
arg_Media_Type | guint (FIXME, generate documentation) |
arg_Direction | guint (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“add-remote-candidate”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   gchar                   *arg_Candidate_ID,
                   gpointer                 user_data)

The AddRemoteCandidate D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Candidate_ID | const gchar * (FIXME, generate documentation) |
arg_Transports | const GPtrArray * (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“close”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   gpointer                 user_data)

The Close D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“remove-remote-candidate”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   gchar                   *arg_Candidate_ID,
                   gpointer                 user_data)

The RemoveRemoteCandidate D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Candidate_ID | const gchar * (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“set-active-candidate-pair”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   gchar                   *arg_Native_Candidate_ID,
                   gchar                   *arg_Remote_Candidate_ID,
                   gpointer                 user_data)

The SetActiveCandidatePair D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Native_Candidate_ID | const gchar * (FIXME, generate documentation) |
arg_Remote_Candidate_ID | const gchar * (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“set-remote-candidate-list”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   gpointer                 user_data)

The SetRemoteCandidateList D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Remote_Candidates | const GPtrArray * (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“set-remote-codecs”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   gpointer                 user_data)

The SetRemoteCodecs D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Codecs | const GPtrArray * (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“set-remote-feedback-messages”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   gpointer                 user_data)

The SetRemoteFeedbackMessages D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Messages | GHashTable * (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“set-remote-header-extensions”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   gpointer                 user_data)

The SetRemoteHeaderExtensions D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Header_Extensions | const GPtrArray * (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“set-stream-held”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   gboolean                 arg_Held,
                   gpointer                 user_data)

The SetStreamHeld D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Held | gboolean (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“set-stream-playing”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   gboolean                 arg_Playing,
                   gpointer                 user_data)

The SetStreamPlaying D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Playing | gboolean (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“set-stream-sending”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   gboolean                 arg_Sending,
                   gpointer                 user_data)

The SetStreamSending D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Sending | gboolean (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“start-named-telephony-event”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   guchar                   arg_Event,
                   guint                    arg_Codec_ID,
                   gpointer                 user_data)

The StartNamedTelephonyEvent D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Event | guchar (FIXME, generate documentation) |
arg_Codec_ID | guint (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“start-sound-telephony-event”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   guchar                   arg_Event,
                   gpointer                 user_data)

The StartSoundTelephonyEvent D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Event | guchar (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“start-telephony-event”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   guchar                   arg_Event,
                   gpointer                 user_data)

The StartTelephonyEvent D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Event | guchar (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“stop-telephony-event”` signal

    void
    user_function (TpSvcMediaStreamHandler *self,
                   gpointer                 user_data)

The StopTelephonyEvent D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

## See Also

TpSvcChannelTypeStreamedMedia